#ifndef _SUBSURFACE_PROFILE_COMMON_GLSL_
#define _SUBSURFACE_PROFILE_COMMON_GLSL_

#include "Definitions.glsl"

#define SUBSURFACE_PROFILE_MAX_NUM 64

// NOTE: Changing offsets below requires updating all instances of #SSSS_CONSTANTS
#define SSSS_SUBSURFACE_COLOR_OFFSET			0
#define SSSS_TRANSMISSION_OFFSET				(SSSS_SUBSURFACE_COLOR_OFFSET+1)
#define SSSS_BOUNDARY_COLOR_BLEED_OFFSET		(SSSS_TRANSMISSION_OFFSET+1)
#define SSSS_DUAL_SPECULAR_OFFSET				(SSSS_BOUNDARY_COLOR_BLEED_OFFSET+1)
#define SSSS_KERNEL0_OFFSET						(SSSS_DUAL_SPECULAR_OFFSET+1)
#define SSSS_KERNEL0_SIZE						13
#define SSSS_KERNEL1_OFFSET						(SSSS_KERNEL0_OFFSET + SSSS_KERNEL0_SIZE)
#define SSSS_KERNEL1_SIZE						9
#define SSSS_KERNEL2_OFFSET						(SSSS_KERNEL1_OFFSET + SSSS_KERNEL1_SIZE)
#define SSSS_KERNEL2_SIZE						6
#define SSSS_KERNEL_TOTAL_SIZE					(SSSS_KERNEL0_SIZE + SSSS_KERNEL1_SIZE + SSSS_KERNEL2_SIZE)
#define SSSS_TRANSMISSION_PROFILE_OFFSET		(SSSS_KERNEL0_OFFSET + SSSS_KERNEL_TOTAL_SIZE)
#define SSSS_TRANSMISSION_PROFILE_SIZE			32
#define SSSS_PROFILE_TEXTURE_WIDTH              (SSSS_TRANSMISSION_PROFILE_OFFSET + SSSS_TRANSMISSION_PROFILE_SIZE)
#define	SSSS_MAX_TRANSMISSION_PROFILE_DISTANCE	5.0 // See MaxTransmissionProfileDistance in ComputeTransmissionProfile(), SeparableSSS.cpp
#define SSSS_MAX_DUAL_SPECULAR_ROUGHNESS		2.0

uniform sampler2D UniParam_SubsurfaceProfileTexture;

bool InternalFunc_UseSubsurfaceProfile(int ShadingModelID)
{
    return (ShadingModelID == SHADING_MODEL_ID_SUBSURFACE_PROFILE || ShadingModelID == SHADING_MODEL_ID_EYE);
}

#endif
