XMATRIX4 = { XType = 'XMATRIX4', IDENTITY = 0 }
setmetatable(XMATRIX4, XMATRIX4)

function XMATRIX4:Set(mat4)
    self._11 = mat4._11
    self._12 = mat4._12
    self._13 = mat4._13
    self._14 = mat4._14
    self._21 = mat4._21
    self._22 = mat4._22
    self._23 = mat4._23
    self._24 = mat4._24
    self._31 = mat4._31
    self._32 = mat4._32
    self._33 = mat4._33
    self._34 = mat4._34
    self._41 = mat4._41
    self._42 = mat4._42
    self._43 = mat4._43
    self._44 = mat4._44

end
function XMATRIX4:Clear()
    self._11 = 0
    self._12 = 0
    self._13 = 0
    self._14 = 0
    self._21 = 0
    self._22 = 0
    self._23 = 0
    self._24 = 0
    self._31 = 0
    self._32 = 0
    self._33 = 0
    self._34 = 0
    self._41 = 0
    self._42 = 0
    self._43 = 0
    self._44 = 0

end
function XMATRIX4:Identity()
    self._11 = 1
    self._12 = 0
    self._13 = 0
    self._14 = 0
    self._21 = 0
    self._22 = 1
    self._23 = 0
    self._24 = 0
    self._31 = 0
    self._32 = 0
    self._33 = 1
    self._34 = 0
    self._41 = 0
    self._42 = 0
    self._43 = 0
    self._44 = 1
end
function XMATRIX4:Transpose()

    local t = self._12
    self._12 = self._21
    self._21 = t

    t = self._13
    self._13 = self._31
    self._31 = t

    t = self._14
    self._14 = self._41
    self._41 = t

    t = self._23
    self._23 = self._32
    self._32 = t

    t = self._24
    self._24 = self._42
    self._42 = t

    t = self._34
    self._34 = self._43
    self._43 = t
end
function XMATRIX4:GetTranspose()
    return XMATRIX4(
            self._11, self._21, self._31, self._41,
            self._12, self._22, self._32, self._42,
            self._13, self._23, self._33, self._43,
            self._14, self._24, self._34, self._44)
end
function XMATRIX4:Inverse()
    self:Set(self:GetInverse())
end
function XMATRIX4:InverseTM()
    self:Set(self:GetInverseTM())
end
function XMATRIX4:GetInverse()
    local mResult = XMATRIX4()
    local fDet = self:Determinant()

    mResult._11 = self:Det3x3(self._22, self._23, self._24, self._32, self._33, self._34, self._42, self._43, self._44)
    mResult._12 = -self:Det3x3(self._12, self._13, self._14, self._32, self._33, self._34, self._42, self._43, self._44)
    mResult._13 = self:Det3x3(self._12, self._13, self._14, self._22, self._23, self._24, self._42, self._43, self._44)
    mResult._14 = -self:Det3x3(self._12, self._13, self._14, self._22, self._23, self._24, self._32, self._33, self._34)

    mResult._21 = -self:Det3x3(self._21, self._23, self._24, self._31, self._33, self._34, self._41, self._43, self._44)
    mResult._22 = self:Det3x3(self._11, self._13, self._14, self._31, self._33, self._34, self._41, self._43, self._44)
    mResult._23 = -self:Det3x3(self._11, self._13, self._14, self._21, self._23, self._24, self._41, self._43, self._44)
    mResult._24 = self:Det3x3(self._11, self._13, self._14, self._21, self._23, self._24, self._31, self._33, self._34)

    mResult._31 = self:Det3x3(self._21, self._22, self._24, self._31, self._32, self._34, self._41, self._42, self._44)
    mResult._32 = -self:Det3x3(self._11, self._12, self._14, self._31, self._32, self._34, self._41, self._42, self._44)
    mResult._33 = self:Det3x3(self._11, self._12, self._14, self._21, self._22, self._24, self._41, self._42, self._44)
    mResult._34 = -self:Det3x3(self._11, self._12, self._14, self._21, self._22, self._24, self._31, self._32, self._34)

    mResult._41 = -self:Det3x3(self._21, self._22, self._23, self._31, self._32, self._33, self._41, self._42, self._43)
    mResult._42 = self:Det3x3(self._11, self._12, self._13, self._31, self._32, self._33, self._41, self._42, self._43)
    mResult._43 = -self:Det3x3(self._11, self._12, self._13, self._21, self._22, self._23, self._41, self._42, self._43)
    mResult._44 = self:Det3x3(self._11, self._12, self._13, self._21, self._22, self._23, self._31, self._32, self._33)

    return mResult / fDet
end
function XMATRIX4:GetInverseTM()

    local fDet = 1 / self:Det3x3(self._11, self. _12, self._13, self. _21, self. _22, self. _23, self. _31, self. _32, self. _33)

    local mat = XMATRIX4()

    mat._11 = fDet * self:Det3x3(self._22, self._23, self._24, self._32, self._33, self._34, self._42, self._43, self._44)
    mat._12 = -fDet * self:Det3x3(self._12, self._13, self._14, self._32, self._33, self._34, self._42, self._43, self._44)
    mat._13 = fDet * self:Det3x3(self._12, self._13, self._14, self._22, self._23, self._24, self._42, self._43, self._44)
    mat._14 = -fDet * self:Det3x3(self._12, self._13, self._14, self._22, self._23, self._24, self._32, self._33, self._34)

    mat._21 = -fDet * self:Det3x3(self._21, self._23, self._24, self._31, self._33, self._34, self._41, self._43, self._44)
    mat._22 = fDet * self:Det3x3(self._11, self._13, self._14, self._31, self._33, self._34, self._41, self._43, self._44)
    mat._23 = -fDet * self:Det3x3(self._11, self._13, self._14, self._21, self._23, self._24, self._41, self._43, self._44)
    mat._24 = fDet * self:Det3x3(self._11, self._13, self._14, self._21, self._23, self._24, self._31, self._33, self._34)

    mat._31 = fDet * self:Det3x3(self._21, self._22, self._24, self._31, self._32, self._34, self._41, self._42, self._44)
    mat._32 = -fDet * self:Det3x3(self._11, self._12, self._14, self._31, self._32, self._34, self._41, self._42, self._44)
    mat._33 = fDet * self:Det3x3(self._11, self._12, self._14, self._21, self._22, self._24, self._41, self._42, self._44)
    mat._34 = -fDet * self:Det3x3(self._11, self._12, self._14, self._21, self._22, self._24, self._31, self._32, self._34)

    mat._41 = -fDet * self:Det3x3(self._21, self._22, self._23, self._31, self._32, self._33, self._41, self._42, self._43)
    mat._42 = fDet * self:Det3x3(self._11, self._12, self._13, self._31, self._32, self._33, self._41, self._42, self._43)
    mat._43 = -fDet * self:Det3x3(self._11, self._12, self._13, self._21, self._22, self._23, self._41, self._42, self._43)
    mat._44 = fDet * self:Det3x3(self._11, self._12, self._13, self._21, self._22, self._23, self._31, self._32, self._33)

    return mat
end
function XMATRIX4:Determinant()
    return self._11 * self:Det3x3(self._22, self. _23, self. _24, self. _32, self. _33, self. _34, self. _42, self. _43, self. _44) -
            self._12 * self:Det3x3(self._21, self. _23, self. _24, self. _31, self. _33, self. _34, self. _41, self. _43, self. _44) +
            self._13 * self:Det3x3(self._21, self. _22, self. _24, self. _31, self. _32, self. _34, self. _41, self. _42, self. _44) -
            self._14 * self:Det3x3(self._21, self. _22, self. _23, self. _31, self. _32, self. _33, self. _41, self. _42, self. _43)
end
function XMATRIX4:Translate(x, y, z)
    self:Identity()
    self._41 = x
    self._42 = y
    self._43 = z
end
function XMATRIX4:RotateX(fRad)
    self:Identity()
    self._22 = math.cos(fRad)
    self._33 = self._22
    self._23 = math.sin(fRad)
    self._32 = -self._23

end
function XMATRIX4:RotateY()
    self:Identity()
    self._11 = math.cos(fRad)
    self._33 = self._11
    self._31 = math.sin(fRad)
    self._13 = -self._31
end
function XMATRIX4:RotateZ()
    self:Identity()
    self._11 = math.cos(fRad)
    self._22 = self._11
    self._12 = math.sin(fRad)
    self._21 = -self._12
end
function XMATRIX4:RotateAxis(...)
    local args = { ... }
    if #args == 2 then
        local vec3_m = args[1].m
        local fRad = args[2]

        local fCos = math.cos(fRad)
        local fSin = math.sin(fRad)

        _11 = (vec3_m[1] * vec3_m[1]) * (1 - fCos) + fCos
        _21 = (vec3_m[1] * vec3_m[2]) * (1 - fCos) - (vec3_m[3] * fSin)
        _31 = (vec3_m[1] * vec3_m[3]) * (1 - fCos) + (vec3_m[2] * fSin)
        _12 = (vec3_m[2] * vec3_m[1]) * (1 - fCos) + (vec3_m[3] * fSin)
        _22 = (vec3_m[2] * vec3_m[2]) * (1 - fCos) + fCos
        _32 = (vec3_m[2] * vec3_m[3]) * (1 - fCos) - (vec3_m[1] * fSin)
        _13 = (vec3_m[3] * vec3_m[1]) * (1 - fCos) - (vec3_m[2] * fSin)
        _23 = (vec3_m[3] * vec3_m[2]) * (1 - fCos) + (vec3_m[1] * fSin)
        _33 = (vec3_m[3] * vec3_m[3]) * (1 - fCos) + fCos

        self._14 = 0
        self._24 = 0
        self._34 = 0

        self._41 = 0
        self._42 = 0
        self._43 = 0

        self._44 = 1

    elseif #args == 3 then
        local vec3Pos = args[1]
        local vec3Axis = args[2]
        local fRad = args[3]

        self:Translate(-vec3Pos.x, -vec3Pos.y, -vec3Pos.z)
        local mat = XMATRIX4()
        mat:RotateAxis(vec3Axis, fRad)
        self:MulMatWith(mat)
        mat:Translate(vec3Pos.x, vec3Pos.y, vec3Pos.z)
        self:MulMatWith(mat)

    end


end
function XMATRIX4:Scale(x, y, z)
    self:Clear()
    self._11 = x
    self._22 = y
    self._33 = z
    self._44 = 1
end
function XMATRIX4:SetRotatePart(mat3)
    self._11 = mat3._11
    self._12 = mat3._12
    self._13 = mat3._13

    self._21 = mat3._21
    self._22 = mat3._22
    self._23 = mat3._23

    self._21 = mat3._21
    self._22 = mat3._22
    self._23 = mat3._23
end
function XMATRIX4:GetRotatePart()
    return XMATRIX3(
            self._11, self._12, self._13,
            self._21, self._22, self._23,
            self._31, self._32, self._33)
end
function XMATRIX4:SetTransPart(vec3)
    self:SetRow(4, vec3)
end
function XMATRIX4:GetTransPart()
    return self:GetRow(4)
end
function XMATRIX4:GetRow(i)
    local m = self.m
    return XVECTOR3(m[i][1], m[i][2], m[i][3])
end
function XMATRIX4:GetCol(i)
    local m = self.m
    return XVECTOR3(m[1][i], m[2][i], m[3][i])
end
function XMATRIX4:SetRow(i, vec3)
    if i == 1 then
        self._11 = vec3.x
        self._12 = vec3.y
        self._13 = vec3.z
    elseif i == 2 then
        self._21 = vec3.x
        self._22 = vec3.y
        self._23 = vec3.z
    elseif i == 3 then
        self._31 = vec3.x
        self._32 = vec3.y
        self._33 = vec3.z
    elseif i == 4 then
        self._41 = vec3.x
        self._42 = vec3.y
        self._43 = vec3.z
    end
end
function XMATRIX4:SetCol(i, vec3)
    if i == 1 then
        self._11 = vec3.x
        self._21 = vec3.y
        self._31 = vec3.z
    elseif i == 2 then
        self._12 = vec3.x
        self._22 = vec3.y
        self._32 = vec3.z
    elseif i == 3 then
        self._13 = vec3.x
        self._23 = vec3.y
        self._33 = vec3.z
    elseif i == 4 then
        self._14 = vec3.x
        self._24 = vec3.y
        self._34 = vec3.z
    end
end
function XMATRIX4:TransformCoord(vec3)
    local w = vec3.x * self._14 + vec3.y * self._24 + vec3.z * self._34 + self._44
    if (math.abs(w) < 1e-6) then
        return XVECTOR3()
    else
        local vRet = XVECTOR3(
                vec3.x * self._11 + vec3.y * self._21 + vec3.z * self._31 + self._41,
                vec3.x * self._12 + vec3.y * self._22 + vec3.z * self._32 + self._42,
                vec3.x * self._13 + vec3.y * self._23 + vec3.z * self._33 + self._43)
        return vRet:MulFloatWith(1 / w)
    end

end
function XMATRIX4:Det3x3(a11, a12, a13, a21, a22, a23, a31, a32, a33)
    return a11 * a22 * a33 + a21 * a32 * a13 + a31 * a12 * a23 -
            a13 * a22 * a31 - a23 * a32 * a11 - a33 * a12 * a21
end
function XMATRIX4:MulVec(vec3)
    return XVECTOR3(
            vec3.x * self._11 + vec3.y * self._21 + vec3.z * self._31,
            vec3.x * self._12 + vec3.y * self._22 + vec3.z * self._32,
            vec3.x * self._13 + vec3.y * self._23 + vec3.z * self._33)

end
function XMATRIX4:MulMatWith(mat)
    self:Set(self * mat)
end
function XMATRIX4:MulFloatWith(float)
    self:Set(self * float)
end
function XMATRIX4:DevFloatWith(float)
    self:Set(self / float)
end
function XMATRIX4:AddMatWith(mat)
    self:Set(self + mat)
end
function XMATRIX4:SubMatWith(mat)
    self:Set(self - mat)
end

function XMATRIX4.__add(arg1, arg2)
    if math.isM4(arg1) and math.isM4(arg2) then
        return XMATRIX4(
                arg1._11 + arg2._11, arg1._12 + arg2._12, arg1._13 + arg2._13, arg1._14 + arg2._14,
                arg1._21 + arg2._21, arg1._22 + arg2._22, arg1._23 + arg2._23, arg1._24 + arg2._24,
                arg1._31 + arg2._31, arg1._32 + arg2._32, arg1._33 + arg2._33, arg1._34 + arg2._34,
                arg1._41 + arg2._41, arg1._42 + arg2._42, arg1._43 + arg2._43, arg1._44 + arg2._44)
    end
    error('Illegal operation: ' .. math.typeName(arg1) .. ' + ' .. math.typeName(arg2))

end
function XMATRIX4.__sub(arg1, arg2)
    if math.isM4(arg1) and math.isM4(arg2) then
        return XMATRIX4(
                arg1._11 - arg2._11, arg1._12 - arg2._12, arg1._13 - arg2._13, arg1._14 - arg2._14,
                arg1._21 - arg2._21, arg1._22 - arg2._22, arg1._23 - arg2._23, arg1._24 - arg2._24,
                arg1._31 - arg2._31, arg1._32 - arg2._32, arg1._33 - arg2._33, arg1._34 - arg2._34,
                arg1._41 - arg2._41, arg1._42 - arg2._42, arg1._43 - arg2._43, arg1._44 - arg2._44)
    end
    error('Illegal operation: ' .. math.typeName(arg1) .. ' - ' .. math.typeName(arg2))
end
function XMATRIX4.__mul(arg1, arg2)

    if math.isM4(arg1) and math.isVec3(arg2) then
        --- m4 * vec3
        return math.mul_m4_vec3(arg1, arg2)
    elseif math.isM4(arg2) and math.isVec3(arg1) then
        --- vec3 * m4
        return math.mul_m4_vec3(arg2, arg1)
    elseif math.isM4(arg1) and math.isNumber(arg2) then
        --- m4 * float
        return math.mul_m4_float(arg1, arg2)
    elseif math.isM4(arg2) and math.isNumber(arg1) then
        --- float * m4
        return math.mul_m4_float(arg2, arg1)
    elseif math.isM4(arg1) and math.isVec4(arg2) then
        --- m4 * vec4
        return math.mul_m4_vec4(arg1, arg2)
    elseif math.isM4(arg2) and math.isVec4(arg1) then
        --- vec4 * m4
        return math.mul_m4_vec4(arg1, arg2)
    elseif math.isM4(arg1) and math.isM4(arg2) then
        --- m4 * m4
        return math.mul_m4_m4(arg1, arg2)
    end
    error('Illegal operation: ' .. math.typeName(arg1) .. ' * ' .. math.typeName(arg2))
end
function XMATRIX4.__div(arg1, arg2)
    if math.isM4(arg1) and math.isNumber(arg2) then
        return XMATRIX4(
                arg1._11 / arg2, arg1._12 / arg2, arg1._13 / arg2, arg1._14 / arg2,
                arg1._21 / arg2, arg1._22 / arg2, arg1._23 / arg2, arg1._24 / arg2,
                arg1._31 / arg2, arg1._32 / arg2, arg1._33 / arg2, arg1._34 / arg2,
                arg1._41 / arg2, arg1._42 / arg2, arg1._43 / arg2, arg1._44 / arg2)
    end
    error('Illegal operation: ' .. math.typeName(arg1) .. ' / ' .. math.typeName(arg2))
end
function XMATRIX4.__eq(arg1, arg2)
    if math.isM4(arg1) and math.isM4(arg2) then
        return arg1._11 == arg2._11 and arg1._12 == arg2._12 and arg1._13 == arg2._13 and arg1._14 == arg2._14 and
                arg1._21 == arg2._21 and arg1._22 == arg2._22 and arg1._23 == arg2._23 and arg1._24 == arg2._24 and
                arg1._31 == arg2._31 and arg1._32 == arg2._32 and arg1._33 == arg2._33 and arg1._34 == arg2._34 and
                arg1._41 == arg2._41 and arg1._42 == arg2._42 and arg1._43 == arg2._43 and arg1._44 == arg2._44
    end
    return false
end
function XMATRIX4:__index(key)
    if key == 'm' then
        return { { self._11, self._12, self._13, self._14 },
                 { self._21, self._22, self._23, self._24 },
                 { self._31, self._32, self._33, self._34 },
                 { self._41, self._42, self._43, self._44 } }
    end
    return rawget(XMATRIX4, key)
end
function XMATRIX4:__tostring()
    return '\nXMATRIX4:[ ' .. tostring(self._11) .. ' ' .. tostring(self._12) .. ' ' .. tostring(self._13) .. ' ' .. tostring(self._14) .. '\n' ..
            '           ' .. tostring(self._21) .. ' ' .. tostring(self._22) .. ' ' .. tostring(self._23) .. ' ' .. tostring(self._24) .. '\n' ..
            '           ' .. tostring(self._31) .. ' ' .. tostring(self._32) .. ' ' .. tostring(self._33) .. ' ' .. tostring(self._34) .. '\n' ..
            '           ' .. tostring(self._41) .. ' ' .. tostring(self._42) .. ' ' .. tostring(self._43) .. ' ' .. tostring(self._44) .. ' ]'

end
function XMATRIX4:__call(...)
    local m4 = {}
    local args = { ... }
    if #args == 0 then
        m4._11 = 0
        m4._12 = 0
        m4._13 = 0
        m4._14 = 0
        m4._21 = 0
        m4._22 = 0
        m4._23 = 0
        m4._24 = 0
        m4._31 = 0
        m4._32 = 0
        m4._33 = 0
        m4._34 = 0
        m4._41 = 0
        m4._42 = 0
        m4._43 = 0
        m4._44 = 0
    elseif #args == 1 then
        local arg = args[1]
        if math.isNumber(arg) and arg == XMATRIX4.IDENTITY then
            m4._11 = 1
            m4._12 = 0
            m4._13 = 0
            m4._14 = 0
            m4._21 = 0
            m4._22 = 1
            m4._23 = 0
            m4._24 = 0
            m4._31 = 0
            m4._32 = 0
            m4._33 = 1
            m4._34 = 0
            m4._41 = 0
            m4._42 = 0
            m4._43 = 0
            m4._44 = 1
        elseif math.isM4(arg) then
            m4._11 = arg._11
            m4._12 = arg._12
            m4._13 = arg._13
            m4._14 = arg._14
            m4._21 = arg._21
            m4._22 = arg._22
            m4._23 = arg._23
            m4._24 = arg._24
            m4._31 = arg._31
            m4._32 = arg._32
            m4._33 = arg._33
            m4._34 = arg._34
            m4._41 = arg._41
            m4._42 = arg._42
            m4._43 = arg._43
            m4._44 = arg._44
        elseif type(arg) == 'table' and #arg == 16 then
            m4._11 = arg[1]
            m4._12 = arg[2]
            m4._13 = arg[3]
            m4._14 = arg[4]
            m4._21 = arg[5]
            m4._22 = arg[6]
            m4._23 = arg[7]
            m4._24 = arg[8]
            m4._31 = arg[9]
            m4._32 = arg[10]
            m4._33 = arg[11]
            m4._34 = arg[12]
            m4._41 = arg[13]
            m4._42 = arg[14]
            m4._43 = arg[15]
            m4._44 = arg[16]
        end
    elseif #args == 16 then
        m4._11 = args[1]
        m4._12 = args[2]
        m4._13 = args[3]
        m4._14 = args[4]
        m4._21 = args[5]
        m4._22 = args[6]
        m4._23 = args[7]
        m4._24 = args[8]
        m4._31 = args[9]
        m4._32 = args[10]
        m4._33 = args[11]
        m4._34 = args[12]
        m4._41 = args[13]
        m4._42 = args[14]
        m4._43 = args[15]
        m4._44 = args[16]
    end

    setmetatable(m4, XMATRIX4)
    return m4

end
