function string.startWith(str, sstr)
    if str == nil then
        return nil
    end
    return str:find('^' .. sstr) ~= nil
end
function string.endwith(str, estr)
    if str == nil or estr == nil then
        return nil
    end
    str_tmp = string.reverse(str)
    substr_tmp = string.reverse(estr)
    if string.find(str_tmp, substr_tmp) ~= 1 then
        return false
    else
        return true
    end
end
function string.trim(str)
    if str == nil then
        return nil
    end
    str = string.gsub(str, " ", "")
    return str
end
function string.capitalize(str)
    if str == nil then
        return nil, "the string parameter is nil"
    end
    local ch = string.sub(str, 1, 1)
    local len = string.len(str)
    if ch < 'a' or ch > 'z' then
        return str
    end
    ch = string.char(string.byte(ch) - 32)
    if len == 1 then
        return ch
    else
        return ch .. string.sub(str, 2, len)
    end
end
function string.count(str, substr, from, to)
    if str == nil or substr == nil then
        return nil, "the string or the sub-string parameter is nil"
    end
    from = from or 1
    if to == nil or to > string.len(str) then
        to = string.len(str)
    end
    local str_tmp = string.sub(str, from, to)
    local n = 0
    _, n = string.gsub(str, substr, '')
    return n
end
function string.expendtabs(str, n)
    if str == nil then
        return nil, "the string parameter is nil"
    end
    n = n or 8
    str = string.gsub(str, "\t", string.rep(" ", n))
    return str
end
function string.isalnum(str)
    if str == nil then
        return nil, "the string parameter is nil"
    end
    local len = string.len(str)
    for i = 1, len do
        local ch = string.sub(str, i, i)
        if not ((ch >= 'a' and ch <= 'z') or (ch >= 'A' and ch <= 'Z') or (ch >= '0' and ch <= '9')) then
            return false
        end
    end
    return true
end
function string.isalpha(str)
    if str == nil then
        return nil, "the string parameter is nil"
    end
    local len = string.len(str)
    for i = 1, len do
        local ch = string.sub(str, i, i)
        if not ((ch >= 'a' and ch <= 'z') or (ch >= 'A' and ch <= 'Z')) then
            return false
        end
    end
    return true
end
function string.isdigit(str)
    if str == nil then
        return nil, "the string parameter is nil"
    end
    local len = string.len(str)
    for i = 1, len do
        local ch = string.sub(str, i, i)
        if ch < '0' or ch > '9' then
            return false
        end
    end
    return true
end
function string.islower(str)
    if str == nil then
        return nil, "the string parameter is nil"
    end
    local len = string.len(str)
    for i = 1, len do
        local ch = string.sub(str, i, i)
        if ch < 'a' or ch > 'z' then
            return false
        end
    end
    return true
end
function string.isupper(str)
    if str == nil then
        return nil, "the string parameter is nil"
    end
    local len = string.len(str)
    for i = 1, len do
        local ch = string.sub(str, i, i)
        if ch < 'A' or ch > 'Z' then
            return false
        end
    end
    return true
end
function string.join(str, substr)
    if str == nil or substr == nil then
        return nil, "the string or the sub-string parameter is nil"
    end
    local xlen = string.len(str) - 1
    if xlen == 0 then
        return str
    end
    local str_tmp = ""
    for i = 1, xlen do
        str_tmp = str_tmp .. string.sub(str, i, i) .. substr
    end
    str_tmp = str_tmp .. string.sub(str, xlen + 1, xlen + 1)
    return str_tmp
end
function string.lower(str)
    if str == nil then
        return nil, "the string parameter is nil"
    end
    local len = string.len(str)
    local str_tmp = ""
    for i = 1, len do
        local ch = string.sub(str, i, i)
        if ch >= 'A' and ch <= 'Z' then
            ch = string.char(string.byte(ch) + 32)
        end
        str_tmp = str_tmp .. ch
    end
    return str_tmp
end
function string.upper(str)
    if str == nil then
        return nil, "the string parameter is nil"
    end
    local len = string.len(str)
    local str_tmp = ""
    for i = 1, len do
        local ch = string.sub(str, i, i)
        if ch >= 'a' and ch <= 'z' then
            ch = string.char(string.byte(ch) - 32)
        end
        str_tmp = str_tmp .. ch
    end
    return str_tmp
end
function string.partition(str, substr)
    if str == nil or substr == nil then
        return nil, "the string or the sub-string parameter is nil"
    end
    local len = string.len(str)
    start_idx, end_idx = string.find(str, substr)
    if start_idx == nil or end_idx == len then
        return str, '', ''
    end
    return string.sub(str, 1, start_idx - 1), string.sub(str, start_idx, end_idx), string.sub(str, end_idx + 1, len)
end
function string.zfill(str, n)
    if str == nil then
        return nil, "the string parameter is nil"
    end
    if n == nil then
        return str
    end
    local format_str = "%0" .. n .. "s"
    return string.format(format_str, str)
end
function string.ljust(str, n, ch)
    if str == nil then
        return nil, "the string parameter is nil"
    end
    ch = ch or " "
    n = tonumber(n) or 0
    local len = string.len(str)
    return string.rep(ch, n - len) .. str
end
function string.rjust(str, n, ch)
    if str == nil then
        return nil, "the string parameter is nil"
    end
    ch = ch or " "
    n = tonumber(n) or 0
    local len = string.len(str)
    return str .. string.rep(ch, n - len)
end
function string.center(str, n, ch)
    if str == nil then
        return nil, "the string parameter is nil"
    end
    ch = ch or " "
    n = tonumber(n) or 0
    local len = string.len(str)
    rn_tmp = math.floor((n - len) / 2)
    ln_tmp = n - rn_tmp - len
    return string.rep(ch, rn_tmp) .. str .. string.rep(ch, ln_tmp)
end

function string.split(input, delimiter)
    input = tostring(input)
    delimiter = tostring(delimiter)
    if (delimiter == '') then
        return false
    end
    local pos, arr = 0, {}
    -- for each divider found
    for st, sp in function()
        return string.find(input, delimiter, pos, true)
    end do
        table.insert(arr, string.sub(input, pos, st - 1))
        pos = sp + 1
    end
    table.insert(arr, string.sub(input, pos))
    return arr
end

string._htmlspecialchars_set = {}
string._htmlspecialchars_set["&"] = "&amp;"
string._htmlspecialchars_set["\""] = "&quot;"
string._htmlspecialchars_set["'"] = "&#039;"
string._htmlspecialchars_set["<"] = "&lt;"
string._htmlspecialchars_set[">"] = "&gt;"

function string.htmlspecialchars(input)
    for k, v in pairs(string._htmlspecialchars_set) do
        input = string.gsub(input, k, v)
    end
    return input
end

function string.restorehtmlspecialchars(input)
    for k, v in pairs(string._htmlspecialchars_set) do
        input = string.gsub(input, v, k)
    end
    return input
end

function string.nl2br(input)
    return string.gsub(input, "\n", "<br />")
end

function string.text2html(input)
    input = string.gsub(input, "\t", "    ")
    input = string.htmlspecialchars(input)
    input = string.gsub(input, " ", "&nbsp;")
    input = string.nl2br(input)
    return input
end

function string.ltrim(input)
    return string.gsub(input, "^[ \t\n\r]+", "")
end

function string.rtrim(input)
    return string.gsub(input, "[ \t\n\r]+$", "")
end

function string.trim(input)
    input = string.gsub(input, "^[ \t\n\r]+", "")
    return string.gsub(input, "[ \t\n\r]+$", "")
end

function string.ucfirst(input)
    return string.upper(string.sub(input, 1, 1)) .. string.sub(input, 2)
end

local function urlencodechar(char)
    return "%" .. string.format("%02X", string.byte(char))
end

function string.urlencode(input)
    -- convert line endings
    input = string.gsub(tostring(input), "\n", "\r\n")
    -- escape all characters but alphanumeric, '.' and '-'
    input = string.gsub(input, "([^%w%.%- ])", urlencodechar)
    -- convert spaces to "+" symbols
    return string.gsub(input, " ", "+")
end

function string.urldecode(input)
    input = string.gsub(input, "+", " ")
    input = string.gsub(input, "%%(%x%x)", function(h)
        return string.char(checknumber(h, 16))
    end)
    input = string.gsub(input, "\r\n", "\n")
    return input
end

function string.utf8len(input)
    local len = string.len(input)
    local left = len
    local cnt = 0
    local arr = { 0, 0xc0, 0xe0, 0xf0, 0xf8, 0xfc }
    while left ~= 0 do
        local tmp = string.byte(input, -left)
        local i = #arr
        while arr[i] do
            if tmp >= arr[i] then
                left = left - i
                break
            end
            i = i - 1
        end
        cnt = cnt + 1
    end
    return cnt
end

function string.formatnumberthousands(num)
    local formatted = tostring(checknumber(num))
    local k
    while true do
        formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1,%2')
        if k == 0 then
            break
        end
    end
    return formatted
end
